<?php
use services\navigation\MenuItem;

if ( !defined( 'IN_CMS' ) ) {
    exit();
}

\IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->get( 'surveys/survey/list', 'plugins\\surveys\controllers\\SurveyController@list' );
    $r->get( 'surveys/survey/add', 'plugins\\surveys\controllers\\SurveyController@addform' );
    $r->post( 'surveys/survey/add', 'plugins\\surveys\controllers\\SurveyController@add' );
    $r->get( 'surveys/survey/update/{id:\\d+}', 'plugins\\surveys\controllers\\SurveyController@updateform' );
    $r->post( 'surveys/survey/update/{id:\\d+}', 'plugins\\surveys\controllers\\SurveyController@update' );
    $r->get( 'surveys/survey/delete/{id:\\d+}', 'plugins\\surveys\controllers\\SurveyController@delete' );
    $r->get( 'surveys/survey/show/{id:\\d+}', 'plugins\\surveys\controllers\\SurveyController@show' );
    $r->post( 'surveys/survey/search', 'plugins\\surveys\controllers\\SurveyController@search' );
    $r->get( 'surveys/question/list', 'plugins\\surveys\controllers\\QuestionController@list' );
    $r->get( 'surveys/question/add', 'plugins\\surveys\controllers\\QuestionController@addform' );
    $r->post( 'surveys/question/add', 'plugins\\surveys\controllers\\QuestionController@add' );
    $r->get( 'surveys/question/update/{id:\\d+}', 'plugins\\surveys\controllers\\QuestionController@updateform' );
    $r->post( 'surveys/question/update/{id:\\d+}', 'plugins\\surveys\controllers\\QuestionController@update' );
    $r->get( 'surveys/question/delete/{id:\\d+}', 'plugins\\surveys\controllers\\QuestionController@delete' );
    $r->post( 'surveys/question/search', 'plugins\\surveys\controllers\\QuestionController@search' );
    $r->get( 'surveys/question/moveup/{id:\\d+}', 'plugins\\surveys\controllers\\QuestionController@moveup' );
    $r->get( 'surveys/question/movedown/{id:\\d+}', 'plugins\\surveys\controllers\\QuestionController@movedown' );
    $r->post( 'surveys/response/create/{id:\\d+}', 'plugins\\surveys\controllers\\SurveyResponsesController@create' );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'after_initialize_backend_menu', function( services\navigation\Menu $backendMenu ) {
    $backendMenu->addItem( new MenuItem( 'surveys', BASE_URL . 'surveys/survey/list' ) );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'check_template_used', function( $template, &$isUsed ) {
    $settings = \IoC::resolve( 'settings' );
    if ( $template->template_id == $settings['surveys.survey_template'] ) {
        $isUsed = true;
        return false;
    }
    return true;
} );

$logger = \IoC::resolve( 'logger' );
$logger->info( 'Plugin surveys initialized.' );
